import { tick } from '@angular/core/testing';
import { Injectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FormControlMock {
    /**
     * @param {?=} type
     */
    constructor(type = 'text') {
        this.nativeElement = document.createElement('input');
        this.nativeElement.setAttribute('type', type);
    }
}
if (false) {
    /** @type {?} */
    FormControlMock.prototype.nativeElement;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 * @param {?} f
 * @param {?=} advanceBy
 * @return {?}
 */
function advance(f, advanceBy = 0) {
    tick(advanceBy);
    f.detectChanges();
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MockToast {
    /**
     * @param {?} message
     * @param {?} context
     * @param {?=} header
     */
    constructor(message, context, header) {
        this.message = message;
        this.context = context;
        this.header = header;
    }
    /**
     * @return {?}
     */
    dismiss() {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        (resolve) => resolve()));
    }
}
if (false) {
    /** @type {?} */
    MockToast.prototype.message;
    /** @type {?} */
    MockToast.prototype.context;
    /** @type {?} */
    MockToast.prototype.header;
}
const ɵ0 = /**
 * @return {?}
 */
() => { }, ɵ1 = /**
 * @param {?} message
 * @param {?=} header
 * @return {?}
 */
(message, header) => {
    return (/** @type {?} */ (new MockToast(message, 'danger', header)));
}, ɵ2 = /**
 * @param {?} message
 * @param {?=} header
 * @return {?}
 */
(message, header) => {
    return (/** @type {?} */ (new MockToast(message, 'info', header)));
}, ɵ3 = /**
 * @param {?} message
 * @param {?=} header
 * @return {?}
 */
(message, header) => {
    return (/** @type {?} */ (new MockToast(message, 'success', header)));
}, ɵ4 = /**
 * @param {?} message
 * @param {?=} header
 * @return {?}
 */
(message, header) => {
    return (/** @type {?} */ (new MockToast(message, 'success', header)));
}, ɵ5 = /**
 * @return {?}
 */
() => {
    return new Promise((/**
     * @param {?} r
     * @return {?}
     */
    r => r(this)));
}, ɵ6 = /**
 * @param {?} name
 * @param {?} fn
 * @return {?}
 */
(name, fn) => { };
/**
 * \@dynamic
 * @type {?}
 */
const mockToastController = {
    dismissAll: (ɵ0),
    error: (ɵ1),
    message: (ɵ2),
    success: (ɵ3),
    warn: (ɵ4),
    componentOnReady: (ɵ5),
    addEventListener: (ɵ6)
};
/**
 * \@dynamic
 */
class MockToastService {
    constructor() {
        this.controller = MockToastService.createController();
    }
    /**
     * @return {?}
     */
    static createController() {
        return (/** @type {?} */ (mockToastController));
    }
    /**
     * @return {?}
     */
    dismissAll() {
        this.controller.dismissAll();
    }
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    error(message, header) {
        return this.controller.error(message, header);
    }
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    message(message, header) {
        return this.controller.message(message, header);
    }
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    success(message, header) {
        return this.controller.success(message, header);
    }
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    warn(message, header) {
        return this.controller.warn(message, header);
    }
}
MockToastService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
MockToastService.ctorParameters = () => [];
if (false) {
    /**
     * @type {?}
     * @private
     */
    MockToastService.prototype.controller;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FormControlMock, MockToast, MockToastService, advance, mockToastController };
//# sourceMappingURL=anjuna-angular-core-testing.js.map
