(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@anjuna/core'), require('@angular/forms'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@anjuna/angular-core', ['exports', '@angular/core', '@anjuna/core', '@angular/forms', 'rxjs'], factory) :
    (global = global || self, factory((global.anjuna = global.anjuna || {}, global.anjuna['angular-core'] = {}), global.ng.core, global.core$1, global.ng.forms, global.rxjs));
}(this, (function (exports, core, core$1, forms, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var LANGUAGE_CODE = new core.InjectionToken('LanguageCode');
    /**
     * @record
     */
    function TranslationsMap() { }
    if (false) {
        /** @type {?} */
        TranslationsMap.prototype.de;
        /** @type {?} */
        TranslationsMap.prototype.en;
        /** @type {?} */
        TranslationsMap.prototype.fr;
        /** @type {?} */
        TranslationsMap.prototype.ja;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var BaseTranslationPipe = /** @class */ (function () {
        function BaseTranslationPipe(language) {
            this.language = language;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        BaseTranslationPipe.prototype.transform = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!this.translations[this.language]) {
                console.warn("Translation file for '" + this.language + "' does not exist.");
                return value;
            }
            return this.translations[this.language][value] || value;
        };
        /** @nocollapse */
        BaseTranslationPipe.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [LANGUAGE_CODE,] }] }
        ]; };
        return BaseTranslationPipe;
    }());
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        BaseTranslationPipe.prototype.translations;
        /**
         * @type {?}
         * @protected
         */
        BaseTranslationPipe.prototype.language;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description A wrapper around the HTML 5 Drag API.
     */
    var DraggableDirective = /** @class */ (function () {
        function DraggableDirective(element) {
            var _this = this;
            this.element = element;
            this.dataFn = (/**
             * @return {?}
             */
            function () { return _this.getData(); });
            this.controller = new core$1.DragController(this.element.nativeElement, this.dataFn).connect();
        }
        /**
         * @private
         * @return {?}
         */
        DraggableDirective.prototype.getData = /**
         * @private
         * @return {?}
         */
        function () {
            return this.anjDraggable;
        };
        DraggableDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[anjDraggable]'
                    },] }
        ];
        /** @nocollapse */
        DraggableDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        DraggableDirective.propDecorators = {
            anjDraggable: [{ type: core.Input }]
        };
        return DraggableDirective;
    }());
    if (false) {
        /**
         * \@description Binds to arbitrary data to be passed via anjDroppable's onDrop event emitter.
         * @type {?}
         */
        DraggableDirective.prototype.anjDraggable;
        /**
         * @type {?}
         * @private
         */
        DraggableDirective.prototype.controller;
        /**
         * @type {?}
         * @private
         */
        DraggableDirective.prototype.dataFn;
        /**
         * @type {?}
         * @private
         */
        DraggableDirective.prototype.element;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@description A wrapper around the HTML 5 Drop API.
     */
    var DroppableDirective = /** @class */ (function () {
        function DroppableDirective(element) {
            this.element = element;
            this.controller = new core$1.DropController(this.element.nativeElement).connect();
        }
        DroppableDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[anjDroppable]'
                    },] }
        ];
        /** @nocollapse */
        DroppableDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        return DroppableDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DroppableDirective.prototype.controller;
        /**
         * @type {?}
         * @private
         */
        DroppableDirective.prototype.element;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DomOutlet = /** @class */ (function () {
        function DomOutlet(targetElement) {
            this.targetElement = targetElement;
        }
        /**
         * @template C
         * @param {?} template
         * @return {?}
         */
        DomOutlet.prototype.attachTemplate = /**
         * @template C
         * @param {?} template
         * @return {?}
         */
        function (template) {
            var _this = this;
            if (this.template.zone.isStable) {
                this._viewRef = this.template.zone.run((/**
                 * @return {?}
                 */
                function () {
                    return template.viewContainerRef.createEmbeddedView(template.templateRef, template.context);
                }));
            }
            else {
                this._viewRef = template.viewContainerRef.createEmbeddedView(template.templateRef, template.context);
            }
            this._viewRef.rootNodes.forEach((/**
             * @param {?} rootNode
             * @return {?}
             */
            function (rootNode) { return _this.targetElement.appendChild(rootNode); }));
            this._viewRef.detectChanges();
            this.setDisposeFn(((/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var index = template.viewContainerRef.indexOf(_this._viewRef);
                if (index !== -1) {
                    template.viewContainerRef.remove(index);
                }
            })));
            return this._viewRef;
        };
        /**
         * @param {?} context
         * @return {?}
         */
        DomOutlet.prototype.updateContext = /**
         * @param {?} context
         * @return {?}
         */
        function (context) {
            for (var prop in context) {
                if (context.hasOwnProperty(prop)) {
                    this._viewRef.context[prop] = context[prop];
                }
            }
            this._viewRef.detectChanges();
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DomOutlet.prototype.setDisposeFn = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.disposeFn = fn;
        };
        /**
         * @param {?} template
         * @return {?}
         */
        DomOutlet.prototype.attach = /**
         * @param {?} template
         * @return {?}
         */
        function (template) {
            this.template = template;
            return this.attachTemplate(template);
        };
        /**
         * @return {?}
         */
        DomOutlet.prototype.detach = /**
         * @return {?}
         */
        function () {
            if (this.template) {
                this.template.setAttachedHost(null);
                this.template = null;
            }
            this.invokeDisposeFn();
        };
        /**
         * @param {?=} removeParent
         * @return {?}
         */
        DomOutlet.prototype.dispose = /**
         * @param {?=} removeParent
         * @return {?}
         */
        function (removeParent) {
            if (removeParent === void 0) { removeParent = true; }
            this.disposeFn();
            if (removeParent && this.targetElement.parentNode != null) {
                this.targetElement.parentNode.removeChild(this.targetElement);
            }
            return undefined;
        };
        /**
         * @private
         * @return {?}
         */
        DomOutlet.prototype.invokeDisposeFn = /**
         * @private
         * @return {?}
         */
        function () {
            if (this.disposeFn) {
                this.disposeFn();
                this.disposeFn = null;
            }
        };
        return DomOutlet;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DomOutlet.prototype.disposeFn;
        /**
         * @type {?}
         * @private
         */
        DomOutlet.prototype.template;
        /**
         * @type {?}
         * @private
         */
        DomOutlet.prototype._viewRef;
        /** @type {?} */
        DomOutlet.prototype.targetElement;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Template = /** @class */ (function () {
        function Template(templateDirective, context) {
            this.templateDirective = templateDirective;
            this.context = context;
        }
        Object.defineProperty(Template.prototype, "origin", {
            get: /**
             * @return {?}
             */
            function () {
                return this.templateDirective.template.elementRef;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Template.prototype, "templateRef", {
            get: /**
             * @return {?}
             */
            function () {
                return this.templateDirective.template;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Template.prototype, "viewContainerRef", {
            get: /**
             * @return {?}
             */
            function () {
                return this.templateDirective.viewContainerRef;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Template.prototype, "zone", {
            get: /**
             * @return {?}
             */
            function () {
                return this.templateDirective.zone;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} host
         * @param {?=} context
         * @return {?}
         */
        Template.prototype.attach = /**
         * @param {?} host
         * @param {?=} context
         * @return {?}
         */
        function (host, context) {
            if (context === void 0) { context = this.context; }
            this.context = context;
            this.host = host;
            return host.attach(this);
        };
        /**
         * @return {?}
         */
        Template.prototype.detach = /**
         * @return {?}
         */
        function () {
            this.context = undefined;
            if (this.host) {
                /** @type {?} */
                var host = this.host;
                this.host = null;
                host.detach();
            }
        };
        /**
         * @param {?} host
         * @return {?}
         */
        Template.prototype.setAttachedHost = /**
         * @param {?} host
         * @return {?}
         */
        function (host) {
            this.host = host;
        };
        return Template;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        Template.prototype.host;
        /**
         * @type {?}
         * @private
         */
        Template.prototype.templateDirective;
        /** @type {?} */
        Template.prototype.context;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TemplateDirective = /** @class */ (function () {
        function TemplateDirective(_template, _viewRef, _zone) {
            this._template = _template;
            this._viewRef = _viewRef;
            this._zone = _zone;
        }
        Object.defineProperty(TemplateDirective.prototype, "anjTemplateOf", {
            set: /**
             * @param {?} name
             * @return {?}
             */
            function (name) {
                this._name = name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TemplateDirective.prototype, "name", {
            get: /**
             * @return {?}
             */
            function () {
                return this._name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TemplateDirective.prototype, "template", {
            get: /**
             * @return {?}
             */
            function () {
                return this._template;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TemplateDirective.prototype, "viewContainerRef", {
            get: /**
             * @return {?}
             */
            function () {
                return this._viewRef;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TemplateDirective.prototype, "zone", {
            get: /**
             * @return {?}
             */
            function () {
                return this._zone;
            },
            enumerable: true,
            configurable: true
        });
        TemplateDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[anjTemplate]'
                    },] }
        ];
        /** @nocollapse */
        TemplateDirective.ctorParameters = function () { return [
            { type: core.TemplateRef },
            { type: core.ViewContainerRef },
            { type: core.NgZone }
        ]; };
        TemplateDirective.propDecorators = {
            anjTemplateOf: [{ type: core.Input }]
        };
        return TemplateDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        TemplateDirective.prototype._name;
        /**
         * @type {?}
         * @private
         */
        TemplateDirective.prototype._template;
        /**
         * @type {?}
         * @private
         */
        TemplateDirective.prototype._viewRef;
        /**
         * @type {?}
         * @private
         */
        TemplateDirective.prototype._zone;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function RowContext() { }
    if (false) {
        /** @type {?} */
        RowContext.prototype.$implicit;
        /** @type {?|undefined} */
        RowContext.prototype.column;
        /** @type {?} */
        RowContext.prototype.index;
    }
    /**
     * @record
     */
    function OutletMap() { }
    /* tslint:disable:directive-selector */
    var AnjTable = /** @class */ (function () {
        function AnjTable(elRef) {
            this.outletRows = [];
            this.element = elRef.nativeElement;
            this.element.renderer = this;
        }
        /**
         * @private
         * @param {?} row
         * @param {?} index
         * @param {?=} column
         * @return {?}
         */
        AnjTable.rowContext = /**
         * @private
         * @param {?} row
         * @param {?} index
         * @param {?=} column
         * @return {?}
         */
        function (row, index, column) {
            return {
                $implicit: row,
                column: column,
                index: index
            };
        };
        /**
         * @private
         * @param {?} outlet
         * @param {?} context
         * @return {?}
         */
        AnjTable.updateContext = /**
         * @private
         * @param {?} outlet
         * @param {?} context
         * @return {?}
         */
        function (outlet, context) {
            outlet.updateContext(context);
        };
        /**
         * @return {?}
         */
        AnjTable.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.outletRows.map((/**
             * @param {?} rowMap
             * @return {?}
             */
            function (rowMap) {
                for (var templateName in rowMap) {
                    if (rowMap[templateName]) {
                        rowMap[templateName] = rowMap[templateName].dispose();
                    }
                }
                return rowMap;
            }));
        };
        /**
         * Fixes https://git.zias.io/ui-foundation/anjuna/issues/876
         * When the columns change, destory all portals without killing the parent node
         */
        /**
         * Fixes https://git.zias.io/ui-foundation/anjuna/issues/876
         * When the columns change, destory all portals without killing the parent node
         * @return {?}
         */
        AnjTable.prototype.onColumnsUpdated = /**
         * Fixes https://git.zias.io/ui-foundation/anjuna/issues/876
         * When the columns change, destory all portals without killing the parent node
         * @return {?}
         */
        function () {
            this.outletRows.map((/**
             * @param {?} rowMap
             * @return {?}
             */
            function (rowMap) {
                for (var templateName in rowMap) {
                    if (rowMap[templateName]) {
                        rowMap[templateName] = rowMap[templateName].dispose(false);
                    }
                }
                return rowMap;
            }));
        };
        /* These next three methods are a mess of duplicated logic - they will probably stay that way until feature complete, then I'll clean em up */
        /* These next three methods are a mess of duplicated logic - they will probably stay that way until feature complete, then I'll clean em up */
        /**
         * @param {?} cell
         * @param {?} offset
         * @param {?} col
         * @param {?} row
         * @param {?} rowIndex
         * @param {?} template
         * @return {?}
         */
        AnjTable.prototype.cellTemplate = /* These next three methods are a mess of duplicated logic - they will probably stay that way until feature complete, then I'll clean em up */
        /**
         * @param {?} cell
         * @param {?} offset
         * @param {?} col
         * @param {?} row
         * @param {?} rowIndex
         * @param {?} template
         * @return {?}
         */
        function (cell, offset, col, row, rowIndex, template) {
            /** @type {?} */
            var rowMap = this.outletRows[rowIndex] || {};
            /** @type {?} */
            var outlet = rowMap[col.name];
            if (!cell) {
                /**
                 * Removing the line:
                 * rowMap[col.name] = outlet ? outlet.dispose() : undefined;
                 * which fixes https://git.zias.io/ui-foundation/anjuna/issues/850.
                 * Like the detail situation, I do not understand why this works..
                 */
                return;
            }
            if (outlet) {
                if (cell !== outlet.targetElement) {
                    this.updateOutlet(outlet, template, cell, AnjTable.rowContext(row, rowIndex, col));
                }
                else {
                    AnjTable.updateContext(outlet, AnjTable.rowContext(row, rowIndex, col));
                }
            }
            else {
                rowMap[col.name] = this.createOutlet(cell, template, AnjTable.rowContext(row, rowIndex, col));
                this.outletRows[rowIndex] = rowMap;
            }
            col.initCell(cell, offset);
        };
        /**
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
        AnjTable.prototype.rowTemplate = /**
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
        function (templateName, targetEl, row, rowIndex) {
            // Dispose row template no longer used for that index
            this.outletRows[rowIndex] = this.filterRowTemplates(this.outletRows[rowIndex], templateName);
            /** @type {?} */
            var outlet = this.outletRows[rowIndex][templateName];
            if (!targetEl) {
                this.outletRows[rowIndex][templateName] = outlet ? outlet.dispose() : undefined;
                return;
            }
            if (outlet) {
                if (targetEl !== outlet.targetElement) {
                    this.updateOutlet(outlet, templateName, targetEl, AnjTable.rowContext(row, rowIndex));
                }
                else {
                    AnjTable.updateContext(outlet, AnjTable.rowContext(row, rowIndex));
                }
            }
            else {
                this.outletRows[rowIndex][templateName] = this.createOutlet(targetEl, templateName, AnjTable.rowContext(row, rowIndex));
                this.outletRows[rowIndex] = this.outletRows[rowIndex];
            }
        };
        /**
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
        AnjTable.prototype.fromTemplate = /**
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} row
         * @param {?} rowIndex
         * @return {?}
         */
        function (templateName, targetEl, row, rowIndex) {
            /** @type {?} */
            var rowMap = this.outletRows[rowIndex] || {};
            /** @type {?} */
            var outlet = rowMap[templateName];
            if (!targetEl) {
                /**
                 * Removing the line:
                 * rowMap[templateName] = outlet ? outlet.dispose() : undefined;
                 * is part of the fix for https://git.zias.io/ui-foundation/anjuna/issues/750
                 * However, I don't grok at all how/why this works. I don't buy it.
                 * So when we eventually get an issue related to master detail, start here.
                 * Put that line back, and fix it right.
                 */
                return;
            }
            if (outlet) {
                if (targetEl !== outlet.targetElement) {
                    this.updateOutlet(outlet, templateName, targetEl, AnjTable.rowContext(row, rowIndex));
                }
                else {
                    AnjTable.updateContext(outlet, AnjTable.rowContext(row, rowIndex));
                }
            }
            else {
                rowMap[templateName] = this.createOutlet(targetEl, templateName, AnjTable.rowContext(row, rowIndex));
                this.outletRows[rowIndex] = rowMap;
            }
        };
        /**
         * @private
         * @param {?} target
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.createOutlet = /**
         * @private
         * @param {?} target
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
        function (target, templateName, context) {
            /** @type {?} */
            var outlet = new DomOutlet(target);
            outlet.attach(this.createTemplate(templateName, context));
            return outlet;
        };
        /**
         * @private
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.createTemplate = /**
         * @private
         * @param {?} templateName
         * @param {?} context
         * @return {?}
         */
        function (templateName, context) {
            /** @type {?} */
            var templateRef = this.templates.find((/**
             * @param {?} t
             * @return {?}
             */
            function (t) { return t.name === templateName; }));
            return new Template(templateRef, context);
        };
        /**
         * @private
         * @param {?} outlet
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} context
         * @return {?}
         */
        AnjTable.prototype.updateOutlet = /**
         * @private
         * @param {?} outlet
         * @param {?} templateName
         * @param {?} targetEl
         * @param {?} context
         * @return {?}
         */
        function (outlet, templateName, targetEl, context) {
            outlet.targetElement = targetEl;
            outlet.detach();
            outlet.attach(this.createTemplate(templateName, context));
        };
        /**
         * Disposes of row templates no longer used in a given row. This ONLY happens if they have specified more than one
         * Template and the end user sorts or filters or otherwise changes the order. If only one template is specified,
         * the output will always match the input -r
         */
        /**
         * Disposes of row templates no longer used in a given row. This ONLY happens if they have specified more than one
         * Template and the end user sorts or filters or otherwise changes the order. If only one template is specified,
         * the output will always match the input -r
         * @private
         * @param {?=} rowMap
         * @param {?=} templateName
         * @return {?}
         */
        AnjTable.prototype.filterRowTemplates = /**
         * Disposes of row templates no longer used in a given row. This ONLY happens if they have specified more than one
         * Template and the end user sorts or filters or otherwise changes the order. If only one template is specified,
         * the output will always match the input -r
         * @private
         * @param {?=} rowMap
         * @param {?=} templateName
         * @return {?}
         */
        function (rowMap, templateName) {
            if (rowMap === void 0) { rowMap = {}; }
            /** @type {?} */
            var updated = {};
            Object.keys(rowMap).forEach((/**
             * @param {?} k
             * @return {?}
             */
            function (k) {
                if (k === templateName) {
                    updated[k] = rowMap[k];
                }
                else {
                    rowMap[k].dispose(false);
                }
            }));
            return updated;
        };
        AnjTable.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-table:not([anjIgnore])',
                    },] }
        ];
        /** @nocollapse */
        AnjTable.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        AnjTable.propDecorators = {
            templates: [{ type: core.ContentChildren, args: [TemplateDirective,] }],
            onColumnsUpdated: [{ type: core.HostListener, args: ['anjColumnsDidUpdate',] }]
        };
        return AnjTable;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AnjTable.prototype.templates;
        /** @type {?} */
        AnjTable.prototype.element;
        /**
         * @type {?}
         * @private
         */
        AnjTable.prototype.outletRows;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var TransitionState = {
        Enter: 0,
        Leave: 1,
        EnterTo: 2,
        Inactive: 3,
    };
    TransitionState[TransitionState.Enter] = 'Enter';
    TransitionState[TransitionState.Leave] = 'Leave';
    TransitionState[TransitionState.EnterTo] = 'EnterTo';
    TransitionState[TransitionState.Inactive] = 'Inactive';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TransitionDirective = /** @class */ (function () {
        function TransitionDirective(renderer, element, mode, name) {
            this.renderer = renderer;
            this.element = element;
            this.mode = mode;
            this.name = name;
            this.state = TransitionState.EnterTo;
            this.end = new core.EventEmitter();
            this.mode = this.mode ? this.mode : 'in-out';
            this.name = this.name ? this.name : 'transition';
        }
        /**
         * @param {?} changes
         * @return {?}
         */
        TransitionDirective.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            this.endTransition();
            if (!changes.anjTransition.previousValue && !changes.anjTransition.currentValue && this.mode !== 'out') {
                this.initEnter();
            }
            else if (!changes.anjTransition.previousValue && changes.anjTransition.currentValue) {
                this.transitionIn();
            }
            else {
                this.transitionOut();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TransitionDirective.prototype.handleTransition = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.target === this.element.nativeElement && TransitionDirective.supportedTransitions.indexOf(event.propertyName) > -1) {
                event.stopPropagation();
                this.end.emit(this.state);
                if (this.state === TransitionState.Enter) {
                    this.endTransition();
                }
                else {
                    if (this.mode !== 'out' && this.anjTransition) {
                        this.transitionIn();
                    }
                    else {
                        this.endTransition();
                    }
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.initEnter = /**
         * @private
         * @return {?}
         */
        function () {
            this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
        };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.transitionIn = /**
         * @private
         * @return {?}
         */
        function () {
            if (this.mode !== 'out') {
                this.state = TransitionState.Enter;
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave");
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
                this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-active");
                this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter");
            }
            else {
                this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                this.endTransition();
            }
        };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.transitionOut = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this.state = TransitionState.Leave;
            if (this.mode !== 'in') {
                this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
                this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-leave");
            }
            else {
                this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
                this.state = TransitionState.EnterTo;
                if (this.anjTransition) {
                    window.setTimeout((/**
                     * @return {?}
                     */
                    function () {
                        _this.transitionIn();
                    }));
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        TransitionDirective.prototype.endTransition = /**
         * @private
         * @return {?}
         */
        function () {
            this.state = TransitionState.Inactive;
            this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter-active");
            this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave-active");
            this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-enter");
            this.renderer.removeClass(this.element.nativeElement, "anj-" + this.name + "-leave");
            if (!this.anjTransition) {
                this.renderer.addClass(this.element.nativeElement, "anj-" + this.name + "-enter-to");
            }
        };
        TransitionDirective.supportedTransitions = ['opacity', 'transform'];
        TransitionDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[anjTransition]'
                    },] }
        ];
        /** @nocollapse */
        TransitionDirective.ctorParameters = function () { return [
            { type: core.Renderer2 },
            { type: core.ElementRef },
            { type: undefined, decorators: [{ type: core.Attribute, args: ['mode',] }] },
            { type: String, decorators: [{ type: core.Attribute, args: ['name',] }] }
        ]; };
        TransitionDirective.propDecorators = {
            anjTransition: [{ type: core.Input }],
            end: [{ type: core.Output }],
            handleTransition: [{ type: core.HostListener, args: ['transitiend', ['$event'],] }]
        };
        return TransitionDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        TransitionDirective.supportedTransitions;
        /** @type {?} */
        TransitionDirective.prototype.anjTransition;
        /** @type {?} */
        TransitionDirective.prototype.end;
        /**
         * @type {?}
         * @private
         */
        TransitionDirective.prototype.state;
        /**
         * @type {?}
         * @private
         */
        TransitionDirective.prototype.renderer;
        /**
         * @type {?}
         * @private
         */
        TransitionDirective.prototype.element;
        /** @type {?} */
        TransitionDirective.prototype.mode;
        /** @type {?} */
        TransitionDirective.prototype.name;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TIME_TIMEZONE_STRING = new core.InjectionToken('TimeTimezoneString');
    /** @type {?} */
    var TIME_MERIDIEM = new core.InjectionToken('TimeMeridiem');
    /** @type {?} */
    var DATE_TIMEZONE_OVERRIDE = new core.InjectionToken('DateTimezoneOverride');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var LocaleDirective = /** @class */ (function () {
        function LocaleDirective(changeRef, _locale, _lang, _timezone) {
            this.changeRef = changeRef;
            if (_locale) {
                this._locale = _locale;
                this._lang = _lang ? _lang : this._locale ? this._locale.split('-')[0] : 'en';
            }
            if (_timezone) {
                this._timezone = _timezone;
            }
            this.changeRef.markForCheck();
        }
        LocaleDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-locale:not([manual])',
                    },] }
        ];
        /** @nocollapse */
        LocaleDirective.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef },
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [core.LOCALE_ID,] }] },
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [LANGUAGE_CODE,] }] },
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [DATE_TIMEZONE_OVERRIDE,] }] }
        ]; };
        LocaleDirective.propDecorators = {
            _locale: [{ type: core.HostBinding, args: ['attr.locale',] }],
            _lang: [{ type: core.HostBinding, args: ['attr.lang',] }],
            _timezone: [{ type: core.HostBinding, args: ['attr.timezone',] }]
        };
        return LocaleDirective;
    }());
    if (false) {
        /** @type {?} */
        LocaleDirective.prototype._locale;
        /** @type {?} */
        LocaleDirective.prototype._lang;
        /** @type {?} */
        LocaleDirective.prototype._timezone;
        /**
         * @type {?}
         * @private
         */
        LocaleDirective.prototype.changeRef;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ValueAccessor = /** @class */ (function () {
        function ValueAccessor(element, parentForm, parentGroup, injector, changeRef) {
            this.element = element;
            this.injector = injector;
            this.changeRef = changeRef;
            /**
             * Enable two-way binding
             */
            this.valueChange = new core.EventEmitter();
            this.onChange = (/**
             * @return {?}
             */
            function () { });
            this.onTouched = (/**
             * @return {?}
             */
            function () { });
            this.parent = parentForm ? parentForm : parentGroup ? parentGroup : null;
        }
        Object.defineProperty(ValueAccessor.prototype, "isInvalid", {
            get: /**
             * @return {?}
             */
            function () {
                if (!this.ngControl) {
                    return false;
                }
                /** @type {?} */
                var isSubmitted = (this.parent && this.parent.submitted);
                return this.ngControl.invalid && (this.ngControl.touched || isSubmitted);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ValueAccessor.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var control = this.injector.get((/** @type {?} */ (forms.NgControl)), null);
            if (control) {
                this.ngControl = (/** @type {?} */ (control.control));
                this.element.nativeElement.validationStrategy = this;
            }
            if (this.parent && this.parent.statusChanges) {
                this.parentSubscription = this.parent.statusChanges.subscribe({
                    next: (/**
                     * @return {?}
                     */
                    function () {
                        _this.changeRef.markForCheck();
                    })
                });
            }
        };
        /**
         * @return {?}
         */
        ValueAccessor.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.parentSubscription) {
                this.parentSubscription.unsubscribe();
            }
        };
        /**
         * @return {?}
         */
        ValueAccessor.prototype.onAnjBlur = /**
         * @return {?}
         */
        function () {
            this.onTouched();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        ValueAccessor.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.element.nativeElement.value = this.lastValue = value == null ? '' : value;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        ValueAccessor.prototype.onChangeEvent = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value !== this.lastValue) {
                this.lastValue = value;
                this.onChange(value);
                this.valueChange.emit(value);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        ValueAccessor.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        ValueAccessor.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        ValueAccessor.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.element.nativeElement.disabled = isDisabled;
        };
        // Called by Anjuna Element, so needs to exist, but Angular does all the hoof-work
        // Called by Anjuna Element, so needs to exist, but Angular does all the hoof-work
        /**
         * @return {?}
         */
        ValueAccessor.prototype.onValidChange = 
        // Called by Anjuna Element, so needs to exist, but Angular does all the hoof-work
        /**
         * @return {?}
         */
        function () { };
        /** @nocollapse */
        ValueAccessor.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: forms.NgForm },
            { type: forms.FormGroupDirective },
            { type: core.Injector },
            { type: core.ChangeDetectorRef, decorators: [{ type: core.Optional }] }
        ]; };
        ValueAccessor.propDecorators = {
            isInvalid: [{ type: core.HostBinding, args: ['attr.invalid',] }],
            valueChange: [{ type: core.Output }],
            onAnjBlur: [{ type: core.HostListener, args: ['anjBlur',] }]
        };
        return ValueAccessor;
    }());
    if (false) {
        /**
         * Enable two-way binding
         * @type {?}
         */
        ValueAccessor.prototype.valueChange;
        /**
         * @type {?}
         * @protected
         */
        ValueAccessor.prototype.ngControl;
        /**
         * @type {?}
         * @protected
         */
        ValueAccessor.prototype.lastValue;
        /**
         * @type {?}
         * @private
         */
        ValueAccessor.prototype.parent;
        /**
         * @type {?}
         * @private
         */
        ValueAccessor.prototype.parentSubscription;
        /**
         * @type {?}
         * @private
         */
        ValueAccessor.prototype.onChange;
        /** @type {?} */
        ValueAccessor.prototype.onTouched;
        /**
         * @type {?}
         * @protected
         */
        ValueAccessor.prototype.element;
        /**
         * @type {?}
         * @protected
         */
        ValueAccessor.prototype.injector;
        /**
         * @type {?}
         * @protected
         */
        ValueAccessor.prototype.changeRef;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var BooleanValueDirective = /** @class */ (function (_super) {
        __extends(BooleanValueDirective, _super);
        function BooleanValueDirective(parentForm, parentFormGroup, element, injector, changeRef) {
            return _super.call(this, element, parentForm, parentFormGroup, injector, changeRef) || this;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        BooleanValueDirective.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.element.nativeElement.checked = this.lastValue = value == null ? false : value;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        BooleanValueDirective.prototype.onAnjChange = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.onChangeEvent(value);
        };
        BooleanValueDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-checkbox, anj-toggle',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: BooleanValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        BooleanValueDirective.ctorParameters = function () { return [
            { type: forms.NgForm, decorators: [{ type: core.Optional }] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }] },
            { type: core.ElementRef },
            { type: core.Injector },
            { type: core.ChangeDetectorRef }
        ]; };
        BooleanValueDirective.propDecorators = {
            onAnjChange: [{ type: core.HostListener, args: ['anjChange', ['$event.target.checked'],] }]
        };
        return BooleanValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@dynamic
     * @abstract
     */
    var AnjunaValidators = /** @class */ (function () {
        function AnjunaValidators() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.date = /**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (!c.value) {
                return;
            }
            /** @type {?} */
            var isValid = true;
            // Handle obvious Invalid Date
            if (c.value.toString() === 'Invalid Date') {
                isValid = false;
                // Handle Moment Date
            }
            else if (typeof c.value._isValid === 'boolean') {
                isValid = c.value._isValid;
                // Handle Native Date
            }
            else {
                isValid = !isNaN(new Date(c.value).getTime());
            }
            if (isValid || c.value === '') {
                return null;
            }
            else {
                return {
                    date: {
                        valid: false
                    }
                };
            }
        };
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.requiredCheck = /**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (c.value) {
                return null;
            }
            else {
                return {
                    required: {
                        valid: false
                    }
                };
            }
        };
        /**
         * @param {?} c
         * @return {?}
         */
        AnjunaValidators.unique = /**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            if (!c.value || !Array.isArray(c.value)) {
                return;
            }
            /** @type {?} */
            var testArray = c.value.filter(Boolean);
            /** @type {?} */
            var isValid = testArray.length === Array.from(new Set(testArray)).length;
            if (isValid) {
                return null;
            }
            else {
                return {
                    unique: {
                        valid: false
                    }
                };
            }
        };
        AnjunaValidators.minDate = (/**
         * @param {?} min
         * @return {?}
         */
        function (min) {
            return (/**
             * @param {?} c
             * @return {?}
             */
            function (c) {
                if (!c.value) {
                    return;
                }
                if (c.value < new Date(min)) {
                    return {
                        min: {
                            valid: false
                        }
                    };
                }
                else {
                    return null;
                }
            });
        });
        AnjunaValidators.maxDate = (/**
         * @param {?} max
         * @return {?}
         */
        function (max) {
            return (/**
             * @param {?} c
             * @return {?}
             */
            function (c) {
                if (!c.value) {
                    return;
                }
                if (c.value > new Date(max)) {
                    return {
                        max: {
                            valid: false
                        }
                    };
                }
                else {
                    return null;
                }
            });
        });
        return AnjunaValidators;
    }());
    if (false) {
        /** @type {?} */
        AnjunaValidators.minDate;
        /** @type {?} */
        AnjunaValidators.maxDate;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var DateValidatorDirective = /** @class */ (function () {
        function DateValidatorDirective() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        DateValidatorDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            return AnjunaValidators.date(c);
        };
        DateValidatorDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[date][ngModel],[date][formControl]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: DateValidatorDirective, multi: true }
                        ]
                    },] }
        ];
        return DateValidatorDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PickerAbstract = /** @class */ (function () {
        function PickerAbstract(_element, changeRef, ngControl) {
            this._element = _element;
            this.changeRef = changeRef;
            this.ngControl = ngControl;
            this.onChange = (/**
             * @return {?}
             */
            function () { });
            this.onTouch = (/**
             * @return {?}
             */
            function () { });
            this.valueChange = new core.EventEmitter();
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
        }
        /**
         * @return {?}
         */
        PickerAbstract.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            this.picker = this._element.nativeElement.querySelector(this.pickerSelector);
            if (this.picker) {
                this.picker.setInputValue(this.innerDateValue);
                this.outerValue = this._element.nativeElement.value;
            }
        };
        // // Start: ControlValueAccessor requirement
        // // Start: ControlValueAccessor requirement
        /**
         * @param {?} newValue
         * @return {?}
         */
        PickerAbstract.prototype.writeValue = 
        // // Start: ControlValueAccessor requirement
        /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            if (this.picker && this.innerDateValue !== newValue) {
                this.picker.setInputValue(newValue);
                this.outerValue = this._element.nativeElement.value;
            }
            this.innerDateValue = newValue;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        PickerAbstract.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        PickerAbstract.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouch = fn;
        };
        // // End: ControlValueAccessor requirements
        // // End: ControlValueAccessor requirements
        /**
         * @param {?} changedVal
         * @return {?}
         */
        PickerAbstract.prototype.changeHandler = 
        // // End: ControlValueAccessor requirements
        /**
         * @param {?} changedVal
         * @return {?}
         */
        function (changedVal) {
            if (changedVal.refreshOuter) {
                this.outerValue = changedVal.outer;
            }
            this.innerDateValue = changedVal.inner;
            this.propogateInnerValueChange();
            this.changeRef.markForCheck();
            // Handle for keyup
            if (changedVal.inner) {
                this.onTouch();
            }
        };
        /**
         * @private
         * @return {?}
         */
        PickerAbstract.prototype.propogateInnerValueChange = /**
         * @private
         * @return {?}
         */
        function () {
            if (this.ngControl) {
                this.ngControl.control.setValue(this.innerDateValue);
            }
            this.valueChange.emit(this.innerDateValue);
        };
        /** @nocollapse */
        PickerAbstract.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.ChangeDetectorRef },
            { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] }
        ]; };
        PickerAbstract.propDecorators = {
            ngModel: [{ type: core.Input }],
            outerValue: [{ type: core.HostBinding, args: ['value',] }]
        };
        return PickerAbstract;
    }());
    if (false) {
        /** @type {?} */
        PickerAbstract.prototype.valueChange;
        /** @type {?} */
        PickerAbstract.prototype.pickerSelector;
        /** @type {?} */
        PickerAbstract.prototype.picker;
        /** @type {?} */
        PickerAbstract.prototype.ngModel;
        /**
         * @type {?}
         * @private
         */
        PickerAbstract.prototype.innerDateValue;
        /** @type {?} */
        PickerAbstract.prototype.outerValue;
        /** @type {?} */
        PickerAbstract.prototype.onChange;
        /** @type {?} */
        PickerAbstract.prototype.onTouch;
        /**
         * @type {?}
         * @private
         */
        PickerAbstract.prototype._element;
        /**
         * @type {?}
         * @private
         */
        PickerAbstract.prototype.changeRef;
        /**
         * @type {?}
         * @private
         */
        PickerAbstract.prototype.ngControl;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DatePickerDirective = /** @class */ (function (_super) {
        __extends(DatePickerDirective, _super);
        function DatePickerDirective(_element, changeRef, ngControl) {
            var _this = _super.call(this, _element, changeRef, ngControl) || this;
            _this.pickerSelector = 'anj-date-picker';
            return _this;
        }
        /**
         * @return {?}
         */
        DatePickerDirective.prototype.onAnjBlur = /**
         * @return {?}
         */
        function () {
            this.onTouch();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        DatePickerDirective.prototype.onAnjDateChange = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.changeHandler(event.detail);
        };
        DatePickerDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-input[anjDatePicker]',
                        exportAs: 'anjDatepickerInput'
                    },] }
        ];
        /** @nocollapse */
        DatePickerDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.ChangeDetectorRef },
            { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] }
        ]; };
        DatePickerDirective.propDecorators = {
            onAnjBlur: [{ type: core.HostListener, args: ['anjBlur',] }],
            onAnjDateChange: [{ type: core.HostListener, args: ['anjDateChange', ['$event'],] }]
        };
        return DatePickerDirective;
    }(PickerAbstract));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var TextValueDirective = /** @class */ (function (_super) {
        __extends(TextValueDirective, _super);
        function TextValueDirective(parentForm, parentFormGroup, element, injector, changeRef) {
            return _super.call(this, element, parentForm, parentFormGroup, injector, changeRef) || this;
        }
        /**
         * @param {?} value
         * @return {?}
         */
        TextValueDirective.prototype.onAnjChange = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.onChangeEvent(value);
        };
        TextValueDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-input, anj-textarea',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: TextValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        TextValueDirective.ctorParameters = function () { return [
            { type: forms.NgForm, decorators: [{ type: core.Optional }] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }] },
            { type: core.ElementRef },
            { type: core.Injector },
            { type: core.ChangeDetectorRef }
        ]; };
        TextValueDirective.propDecorators = {
            onAnjChange: [{ type: core.HostListener, args: ['anjChange', ['$event.detail.value'],] }]
        };
        return TextValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var RequiredCheckDirective = /** @class */ (function () {
        function RequiredCheckDirective() {
        }
        /**
         * @param {?} c
         * @return {?}
         */
        RequiredCheckDirective.prototype.validate = /**
         * @param {?} c
         * @return {?}
         */
        function (c) {
            return AnjunaValidators.requiredCheck(c);
        };
        RequiredCheckDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-checkbox[required][ngModel], anj-toggle[required][ngModel]',
                        providers: [
                            { provide: forms.NG_VALIDATORS, useExisting: RequiredCheckDirective, multi: true }
                        ]
                    },] }
        ];
        return RequiredCheckDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var SelectValueDirective = /** @class */ (function (_super) {
        __extends(SelectValueDirective, _super);
        function SelectValueDirective(parentForm, parentFormGroup, element, injector, changeRef) {
            return _super.call(this, element, parentForm, parentFormGroup, injector, changeRef) || this;
        }
        /**
         * @param {?} target
         * @return {?}
         */
        SelectValueDirective.prototype.onAnjChange = /**
         * @param {?} target
         * @return {?}
         */
        function (target) {
            // ignore the input for type-aheads
            if (target.matches('anj-input')) {
                return;
            }
            this.onChangeEvent(target.value);
        };
        SelectValueDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-radio-group, anj-select, anj-type-ahead',
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: SelectValueDirective,
                                multi: true
                            }
                        ]
                    },] }
        ];
        /** @nocollapse */
        SelectValueDirective.ctorParameters = function () { return [
            { type: forms.NgForm, decorators: [{ type: core.Optional }] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }] },
            { type: core.ElementRef },
            { type: core.Injector },
            { type: core.ChangeDetectorRef }
        ]; };
        SelectValueDirective.propDecorators = {
            onAnjChange: [{ type: core.HostListener, args: ['anjChange', ['$event.target'],] }]
        };
        return SelectValueDirective;
    }(ValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TimePickerDirective = /** @class */ (function () {
        function TimePickerDirective(_element, ngControl, _timezone, _meridiem) {
            this._element = _element;
            this.ngControl = ngControl;
            this._timezone = _timezone;
            this._meridiem = _meridiem;
            this.onChange = (/**
             * @return {?}
             */
            function () { });
            this.onTouch = (/**
             * @return {?}
             */
            function () { });
            this.valueChange = new core.EventEmitter();
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
        }
        /**
         * @return {?}
         */
        TimePickerDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var picker = this._element.nativeElement.querySelector('anj-time-picker');
            picker.setAttribute('meridiem', this._meridiem);
            if (this._timezone) {
                picker.setAttribute('timezone', this._timezone);
            }
        };
        // // Start: ControlValueAccessor requirements
        // // Start: ControlValueAccessor requirements
        /**
         * @param {?} newValue
         * @return {?}
         */
        TimePickerDirective.prototype.writeValue = 
        // // Start: ControlValueAccessor requirements
        /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this.value = newValue;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        TimePickerDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        TimePickerDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouch = fn;
        };
        // // End: ControlValueAccessor requirements
        // // End: ControlValueAccessor requirements
        /**
         * @param {?} event
         * @return {?}
         */
        TimePickerDirective.prototype.onInput = 
        // // End: ControlValueAccessor requirements
        /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.value = event.detail;
            if (this.ngControl) {
                this.ngControl.control.setValue(this.value);
            }
            this.valueChange.emit(this.value);
        };
        TimePickerDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-input[anjTimePicker]',
                        exportAs: 'anjTimepickerInput'
                    },] }
        ];
        /** @nocollapse */
        TimePickerDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] },
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [TIME_TIMEZONE_STRING,] }] },
            { type: Boolean, decorators: [{ type: core.Optional }, { type: core.Inject, args: [TIME_MERIDIEM,] }] }
        ]; };
        TimePickerDirective.propDecorators = {
            value: [{ type: core.HostBinding, args: ['value',] }],
            onInput: [{ type: core.HostListener, args: ['anjClockSelection', ['$event'],] }]
        };
        return TimePickerDirective;
    }());
    if (false) {
        /** @type {?} */
        TimePickerDirective.prototype.valueChange;
        /** @type {?} */
        TimePickerDirective.prototype.value;
        /** @type {?} */
        TimePickerDirective.prototype.onChange;
        /** @type {?} */
        TimePickerDirective.prototype.onTouch;
        /**
         * @type {?}
         * @private
         */
        TimePickerDirective.prototype._element;
        /**
         * @type {?}
         * @private
         */
        TimePickerDirective.prototype.ngControl;
        /**
         * @type {?}
         * @private
         */
        TimePickerDirective.prototype._timezone;
        /**
         * @type {?}
         * @private
         */
        TimePickerDirective.prototype._meridiem;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function ZuoraDatePipeOptions() { }
    if (false) {
        /** @type {?|undefined} */
        ZuoraDatePipeOptions.prototype.weekday;
        /** @type {?|undefined} */
        ZuoraDatePipeOptions.prototype.era;
        /** @type {?|undefined} */
        ZuoraDatePipeOptions.prototype.year;
        /** @type {?|undefined} */
        ZuoraDatePipeOptions.prototype.month;
        /** @type {?|undefined} */
        ZuoraDatePipeOptions.prototype.day;
        /** @type {?|undefined} */
        ZuoraDatePipeOptions.prototype.hour;
        /** @type {?|undefined} */
        ZuoraDatePipeOptions.prototype.minute;
        /** @type {?|undefined} */
        ZuoraDatePipeOptions.prototype.second;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function DateSegments() { }
    if (false) {
        /** @type {?} */
        DateSegments.prototype.splitDate;
        /** @type {?} */
        DateSegments.prototype.year;
        /** @type {?} */
        DateSegments.prototype.month;
        /** @type {?} */
        DateSegments.prototype.day;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function DateValidationResult() { }
    if (false) {
        /** @type {?} */
        DateValidationResult.prototype.date;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function MaxValidationResult() { }
    if (false) {
        /** @type {?} */
        MaxValidationResult.prototype.max;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function MinValidationResult() { }
    if (false) {
        /** @type {?} */
        MinValidationResult.prototype.min;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function RequiredCheckResult() { }
    if (false) {
        /** @type {?} */
        RequiredCheckResult.prototype.required;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function Time() { }
    if (false) {
        /** @type {?} */
        Time.prototype.hour;
        /** @type {?} */
        Time.prototype.minutes;
        /** @type {?|undefined} */
        Time.prototype.control;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function TimeFields() { }
    if (false) {
        /** @type {?} */
        TimeFields.prototype.meridiem;
        /** @type {?} */
        TimeFields.prototype.military;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function UniqueValidationResult() { }
    if (false) {
        /** @type {?} */
        UniqueValidationResult.prototype.unique;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ZuoraDatePipe = /** @class */ (function () {
        function ZuoraDatePipe(_locale) {
            this._locale = _locale;
        }
        /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
        ZuoraDatePipe.prototype.transform = /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
        function (value, args) {
            try {
                /** @type {?} */
                var valueAsDate = this.convertToDate(value);
                /** @type {?} */
                var userOpts = (/** @type {?} */ (args));
                /** @type {?} */
                var defaultOpts = { year: '2-digit', month: 'numeric', day: 'numeric' };
                /** @type {?} */
                var opts = Object.assign({}, defaultOpts, userOpts);
                return new Intl.DateTimeFormat(this._locale, opts).format(valueAsDate);
            }
            catch (e) {
                return value.toString();
            }
        };
        /*
            Sometimes JS is awful, handles for 'YYYY-MM-DD' to choose local timezone instead of UTC
            https://stackoverflow.com/questions/2587345/why-does-date-parse-give-incorrect-results
         */
        /*
                Sometimes JS is awful, handles for 'YYYY-MM-DD' to choose local timezone instead of UTC
                https://stackoverflow.com/questions/2587345/why-does-date-parse-give-incorrect-results
             */
        /**
         * @private
         * @param {?} input
         * @return {?}
         */
        ZuoraDatePipe.prototype.convertToDate = /*
                Sometimes JS is awful, handles for 'YYYY-MM-DD' to choose local timezone instead of UTC
                https://stackoverflow.com/questions/2587345/why-does-date-parse-give-incorrect-results
             */
        /**
         * @private
         * @param {?} input
         * @return {?}
         */
        function (input) {
            if (this.isIsoUtc(input)) {
                /** @type {?} */
                var splitString = input.split('-');
                return new Date(Number(splitString[0]), Number(splitString[1]) - 1, Number(splitString[2]));
            }
            else {
                return new Date(input);
            }
        };
        /**
         * @private
         * @param {?} input
         * @return {?}
         */
        ZuoraDatePipe.prototype.isIsoUtc = /**
         * @private
         * @param {?} input
         * @return {?}
         */
        function (input) {
            return typeof input === 'string' && input.charAt(4) === '-' && input.charAt(7) === '-' && input.length === 10;
        };
        ZuoraDatePipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'zuoraDate'
                    },] }
        ];
        /** @nocollapse */
        ZuoraDatePipe.ctorParameters = function () { return [
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [core.LOCALE_ID,] }] }
        ]; };
        return ZuoraDatePipe;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ZuoraDatePipe.prototype._locale;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastService = /** @class */ (function () {
        function ToastService() {
            this._dismissed$ = new rxjs.Subject();
        }
        Object.defineProperty(ToastService.prototype, "dismissed$", {
            get: /**
             * @return {?}
             */
            function () {
                return this._dismissed$.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ToastService.createController = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var controller = document.createElement('anj-toast-controller');
            document.body.appendChild(controller);
            return (/** @type {?} */ (controller));
        };
        /**
         * @return {?}
         */
        ToastService.prototype.dismissAll = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var controller;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getController()];
                        case 1:
                            controller = _a.sent();
                            return [2 /*return*/, controller.dismissAll()];
                    }
                });
            });
        };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.error = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        function (message, header) {
            return __awaiter(this, void 0, void 0, function () {
                var controller;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getController()];
                        case 1:
                            controller = _a.sent();
                            return [2 /*return*/, controller.error(message, header)];
                    }
                });
            });
        };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.message = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        function (message, header) {
            return __awaiter(this, void 0, void 0, function () {
                var controller;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getController()];
                        case 1:
                            controller = _a.sent();
                            return [2 /*return*/, controller.message(message, header)];
                    }
                });
            });
        };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.success = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        function (message, header) {
            return __awaiter(this, void 0, void 0, function () {
                var controller;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getController()];
                        case 1:
                            controller = _a.sent();
                            return [2 /*return*/, controller.success(message, header)];
                    }
                });
            });
        };
        /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        ToastService.prototype.warn = /**
         * @param {?} message
         * @param {?=} header
         * @return {?}
         */
        function (message, header) {
            return __awaiter(this, void 0, void 0, function () {
                var controller;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getController()];
                        case 1:
                            controller = _a.sent();
                            return [2 /*return*/, controller.warn(message, header)];
                    }
                });
            });
        };
        /**
         * @return {?}
         */
        ToastService.prototype.getController = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.controller || this.findController()];
                });
            });
        };
        /**
         * @private
         * @return {?}
         */
        ToastService.prototype.findController = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var controller = this.findOrCreate(document.querySelector('anj-toast-controller'));
            controller.addEventListener('anjToastDidDismiss', this.onToastDidDismiss.bind(this));
            this.controller = controller;
            return controller.componentOnReady();
        };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        ToastService.prototype.onToastDidDismiss = /**
         * @private
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this._dismissed$.next(event);
        };
        /**
         * @private
         * @param {?} control
         * @return {?}
         */
        ToastService.prototype.findOrCreate = /**
         * @private
         * @param {?} control
         * @return {?}
         */
        function (control) {
            return control || ToastService.createController();
        };
        ToastService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ ToastService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ToastService_Factory() { return new ToastService(); }, token: ToastService, providedIn: "root" });
        return ToastService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ToastService.prototype.controller;
        /**
         * @type {?}
         * @private
         */
        ToastService.prototype._dismissed$;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LocalStorageService = /** @class */ (function (_super) {
        __extends(LocalStorageService, _super);
        function LocalStorageService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        LocalStorageService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ LocalStorageService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function LocalStorageService_Factory() { return new LocalStorageService(); }, token: LocalStorageService, providedIn: "root" });
        return LocalStorageService;
    }(core$1.LocalStorage));
    var SessionStorageService = /** @class */ (function (_super) {
        __extends(SessionStorageService, _super);
        function SessionStorageService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SessionStorageService.decorators = [
            { type: core.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */ SessionStorageService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function SessionStorageService_Factory() { return new SessionStorageService(); }, token: SessionStorageService, providedIn: "root" });
        return SessionStorageService;
    }(core$1.SessionStorage));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DatetimePickerDirective = /** @class */ (function (_super) {
        __extends(DatetimePickerDirective, _super);
        function DatetimePickerDirective(_element, changeRef, ngControl, _meridiem) {
            var _this = _super.call(this, _element, changeRef, ngControl) || this;
            _this._meridiem = _meridiem;
            _this.pickerSelector = 'anj-datetime-picker';
            return _this;
        }
        /**
         * @return {?}
         */
        DatetimePickerDirective.prototype.onAnjBlur = /**
         * @return {?}
         */
        function () {
            this.onTouch();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        DatetimePickerDirective.prototype.onAnjDatetimeChange = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.changeHandler(event.detail);
        };
        /**
         * @return {?}
         */
        DatetimePickerDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            _super.prototype.ngAfterViewInit.call(this);
            this.picker.setAttribute('meridiem', this._meridiem);
        };
        DatetimePickerDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-input[anjDatetimePicker]',
                        exportAs: 'anjDatetimePickerInput'
                    },] }
        ];
        /** @nocollapse */
        DatetimePickerDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.ChangeDetectorRef },
            { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] },
            { type: Boolean, decorators: [{ type: core.Optional }, { type: core.Inject, args: [TIME_MERIDIEM,] }] }
        ]; };
        DatetimePickerDirective.propDecorators = {
            onAnjBlur: [{ type: core.HostListener, args: ['anjBlur',] }],
            onAnjDatetimeChange: [{ type: core.HostListener, args: ['anjDatetimeChange', ['$event'],] }]
        };
        return DatetimePickerDirective;
    }(PickerAbstract));
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DatetimePickerDirective.prototype._meridiem;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /* tslint:disable:directive-selector */
    var ListValueDirective = /** @class */ (function () {
        function ListValueDirective(_element, changeRef, parentForm, parentGroup, ngControl) {
            this._element = _element;
            this.changeRef = changeRef;
            this.ngControl = ngControl;
            this.valueChange = new core.EventEmitter();
            this.onChange = (/**
             * @return {?}
             */
            function () { });
            this.onTouch = (/**
             * @return {?}
             */
            function () { });
            this.parent = parentForm ? parentForm : parentGroup ? parentGroup : null;
            if (this.ngControl) {
                this.ngControl.valueAccessor = this;
            }
        }
        Object.defineProperty(ListValueDirective.prototype, "parsedField", {
            get: /**
             * @return {?}
             */
            function () {
                return (this.field) ? this.field.parsedList : undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ListValueDirective.prototype, "list", {
            get: /**
             * @return {?}
             */
            function () {
                if (!this._list) {
                    this.list = this._element.nativeElement;
                }
                return this._list;
            },
            set: /**
             * @param {?} el
             * @return {?}
             */
            function (el) {
                this._list = el;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ListValueDirective.prototype.onAnjBlur = /**
         * @return {?}
         */
        function () {
            this.onTouch();
        };
        /**
         * @param {?} target
         * @return {?}
         */
        ListValueDirective.prototype.onAnjChange = /**
         * @param {?} target
         * @return {?}
         */
        function (target) {
            if (!target.matches('anj-list')) {
                return;
            }
            this.changeHandler(target.value.slice(0));
        };
        Object.defineProperty(ListValueDirective.prototype, "isInvalid", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.ngControl) {
                    /** @type {?} */
                    var isSubmitted = (this.parent && this.parent.submitted);
                    return (this.ngControl.invalid && (this.ngControl.touched || isSubmitted));
                }
                if (this.control) {
                    return this.control.invalid;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ListValueDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            if ((this.ngControl && this.ngControl.value) || this.ngModel) {
                this.value = this.ngModel || this.ngControl.value;
                this.list.value = this.value;
                this.changeRef.detectChanges();
            }
        };
        /**
         * @return {?}
         */
        ListValueDirective.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            this.setAttributes();
            if (this.control && this.control.value) {
                this.value = this.control.value;
                this.list.value = this.value;
                this.changeRef.detectChanges();
            }
        };
        /**
         * @return {?}
         */
        ListValueDirective.prototype.setAttributes = /**
         * @return {?}
         */
        function () {
            if (this.field) {
                this.list.setAttribute('min', this.field.minItems || this.list.min);
                this.list.setAttribute('max', this.field.maxItems || this.list.max);
            }
            if (this.parsedField) {
                this.list.setAttribute('options', this.parsedField.options || this.list.options);
                this.list.setAttribute('type', this.parsedField.toInputType() || this.list.type);
            }
        };
        // Start: ControlValueAccessor requirements
        // Start: ControlValueAccessor requirements
        /**
         * @param {?} newValue
         * @return {?}
         */
        ListValueDirective.prototype.writeValue = 
        // Start: ControlValueAccessor requirements
        /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this.value = newValue;
            this.list.value = this.value;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        ListValueDirective.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        ListValueDirective.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this.onTouch = fn;
        };
        // End: ControlValueAccessor requirements
        // End: ControlValueAccessor requirements
        /**
         * @private
         * @param {?} changedVal
         * @return {?}
         */
        ListValueDirective.prototype.changeHandler = 
        // End: ControlValueAccessor requirements
        /**
         * @private
         * @param {?} changedVal
         * @return {?}
         */
        function (changedVal) {
            this.onTouch();
            this.value = changedVal;
            this.valueChange.emit(this.value);
            this.propogateValueChange();
        };
        /**
         * @private
         * @return {?}
         */
        ListValueDirective.prototype.propogateValueChange = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.ngControl) {
                this.ngControl.control.patchValue(this.value);
            }
            else if (this.control) {
                this.control.controls = [];
                this.value.map((/**
                 * @param {?} value
                 * @return {?}
                 */
                function (value) {
                    return _this.control.push(new forms.FormControl(value));
                }));
            }
            this.changeRef.detectChanges();
        };
        ListValueDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: 'anj-list'
                    },] }
        ];
        /** @nocollapse */
        ListValueDirective.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.ChangeDetectorRef },
            { type: forms.NgForm, decorators: [{ type: core.Optional }] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }] },
            { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self }] }
        ]; };
        ListValueDirective.propDecorators = {
            ngModel: [{ type: core.Input }],
            control: [{ type: core.Input }],
            field: [{ type: core.Input }],
            valueChange: [{ type: core.Output }],
            onAnjBlur: [{ type: core.HostListener, args: ['anjBlur',] }],
            onAnjChange: [{ type: core.HostListener, args: ['anjChange', ['$event.target'],] }],
            isInvalid: [{ type: core.HostBinding, args: ['attr.invalid',] }]
        };
        return ListValueDirective;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ListValueDirective.prototype._list;
        /**
         * @type {?}
         * @private
         */
        ListValueDirective.prototype.parent;
        /** @type {?} */
        ListValueDirective.prototype.value;
        /** @type {?} */
        ListValueDirective.prototype.ngModel;
        /** @type {?} */
        ListValueDirective.prototype.control;
        /** @type {?} */
        ListValueDirective.prototype.field;
        /** @type {?} */
        ListValueDirective.prototype.valueChange;
        /** @type {?} */
        ListValueDirective.prototype.onChange;
        /** @type {?} */
        ListValueDirective.prototype.onTouch;
        /**
         * @type {?}
         * @private
         */
        ListValueDirective.prototype._element;
        /**
         * @type {?}
         * @private
         */
        ListValueDirective.prototype.changeRef;
        /**
         * @type {?}
         * @private
         */
        ListValueDirective.prototype.ngControl;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DECLARATIONS = [
        // Common
        DraggableDirective,
        DroppableDirective,
        LocaleDirective,
        TemplateDirective,
        TransitionDirective,
        ZuoraDatePipe,
        // Forms
        BooleanValueDirective,
        DatePickerDirective,
        DatetimePickerDirective,
        DateValidatorDirective,
        ListValueDirective,
        RequiredCheckDirective,
        SelectValueDirective,
        TextValueDirective,
        TimePickerDirective,
        // Tables
        AnjTable
    ];
    var AnjunaCoreModule = /** @class */ (function () {
        function AnjunaCoreModule() {
        }
        AnjunaCoreModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: DECLARATIONS,
                        exports: DECLARATIONS,
                        providers: [
                            {
                                provide: TIME_MERIDIEM,
                                useValue: true
                            },
                            ZuoraDatePipe
                        ]
                    },] }
        ];
        return AnjunaCoreModule;
    }());

    exports.AnjTable = AnjTable;
    exports.AnjunaCoreModule = AnjunaCoreModule;
    exports.AnjunaValidators = AnjunaValidators;
    exports.BaseTranslationPipe = BaseTranslationPipe;
    exports.BooleanValueDirective = BooleanValueDirective;
    exports.DATE_TIMEZONE_OVERRIDE = DATE_TIMEZONE_OVERRIDE;
    exports.DatePickerDirective = DatePickerDirective;
    exports.DateValidatorDirective = DateValidatorDirective;
    exports.DomOutlet = DomOutlet;
    exports.DraggableDirective = DraggableDirective;
    exports.DroppableDirective = DroppableDirective;
    exports.LANGUAGE_CODE = LANGUAGE_CODE;
    exports.LocalStorageService = LocalStorageService;
    exports.LocaleDirective = LocaleDirective;
    exports.RequiredCheckDirective = RequiredCheckDirective;
    exports.SelectValueDirective = SelectValueDirective;
    exports.SessionStorageService = SessionStorageService;
    exports.TIME_MERIDIEM = TIME_MERIDIEM;
    exports.TIME_TIMEZONE_STRING = TIME_TIMEZONE_STRING;
    exports.Template = Template;
    exports.TemplateDirective = TemplateDirective;
    exports.TextValueDirective = TextValueDirective;
    exports.TimePickerDirective = TimePickerDirective;
    exports.ToastService = ToastService;
    exports.TransitionDirective = TransitionDirective;
    exports.TransitionState = TransitionState;
    exports.ZuoraDatePipe = ZuoraDatePipe;
    exports.ɵa = ValueAccessor;
    exports.ɵb = PickerAbstract;
    exports.ɵc = DatetimePickerDirective;
    exports.ɵd = ListValueDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=anjuna-angular-core.umd.js.map
