import { tick } from '@angular/core/testing';
import { Injectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FormControlMock = /** @class */ (function () {
    function FormControlMock(type) {
        if (type === void 0) { type = 'text'; }
        this.nativeElement = document.createElement('input');
        this.nativeElement.setAttribute('type', type);
    }
    return FormControlMock;
}());
if (false) {
    /** @type {?} */
    FormControlMock.prototype.nativeElement;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template T
 * @param {?} f
 * @param {?=} advanceBy
 * @return {?}
 */
function advance(f, advanceBy) {
    if (advanceBy === void 0) { advanceBy = 0; }
    tick(advanceBy);
    f.detectChanges();
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var _this = this;
var MockToast = /** @class */ (function () {
    function MockToast(message, context, header) {
        this.message = message;
        this.context = context;
        this.header = header;
    }
    /**
     * @return {?}
     */
    MockToast.prototype.dismiss = /**
     * @return {?}
     */
    function () {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) { return resolve(); }));
    };
    return MockToast;
}());
if (false) {
    /** @type {?} */
    MockToast.prototype.message;
    /** @type {?} */
    MockToast.prototype.context;
    /** @type {?} */
    MockToast.prototype.header;
}
var ɵ0 = /**
 * @return {?}
 */
function () { }, ɵ1 = /**
 * @param {?} message
 * @param {?=} header
 * @return {?}
 */
function (message, header) {
    return (/** @type {?} */ (new MockToast(message, 'danger', header)));
}, ɵ2 = /**
 * @param {?} message
 * @param {?=} header
 * @return {?}
 */
function (message, header) {
    return (/** @type {?} */ (new MockToast(message, 'info', header)));
}, ɵ3 = /**
 * @param {?} message
 * @param {?=} header
 * @return {?}
 */
function (message, header) {
    return (/** @type {?} */ (new MockToast(message, 'success', header)));
}, ɵ4 = /**
 * @param {?} message
 * @param {?=} header
 * @return {?}
 */
function (message, header) {
    return (/** @type {?} */ (new MockToast(message, 'success', header)));
}, ɵ5 = /**
 * @return {?}
 */
function () {
    return new Promise((/**
     * @param {?} r
     * @return {?}
     */
    function (r) { return r(_this); }));
}, ɵ6 = /**
 * @param {?} name
 * @param {?} fn
 * @return {?}
 */
function (name, fn) { };
/**
 * \@dynamic
 * @type {?}
 */
var mockToastController = {
    dismissAll: (ɵ0),
    error: (ɵ1),
    message: (ɵ2),
    success: (ɵ3),
    warn: (ɵ4),
    componentOnReady: (ɵ5),
    addEventListener: (ɵ6)
};
/**
 * \@dynamic
 */
var MockToastService = /** @class */ (function () {
    function MockToastService() {
        this.controller = MockToastService.createController();
    }
    /**
     * @return {?}
     */
    MockToastService.createController = /**
     * @return {?}
     */
    function () {
        return (/** @type {?} */ (mockToastController));
    };
    /**
     * @return {?}
     */
    MockToastService.prototype.dismissAll = /**
     * @return {?}
     */
    function () {
        this.controller.dismissAll();
    };
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    MockToastService.prototype.error = /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    function (message, header) {
        return this.controller.error(message, header);
    };
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    MockToastService.prototype.message = /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    function (message, header) {
        return this.controller.message(message, header);
    };
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    MockToastService.prototype.success = /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    function (message, header) {
        return this.controller.success(message, header);
    };
    /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    MockToastService.prototype.warn = /**
     * @param {?} message
     * @param {?=} header
     * @return {?}
     */
    function (message, header) {
        return this.controller.warn(message, header);
    };
    MockToastService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    MockToastService.ctorParameters = function () { return []; };
    return MockToastService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    MockToastService.prototype.controller;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FormControlMock, MockToast, MockToastService, advance, mockToastController };
//# sourceMappingURL=anjuna-angular-core-testing.js.map
